<?php

namespace FiloBlu\CustomerBlocker\Model\Paypal\Express;

class Checkout extends \Magento\Paypal\Model\Express\Checkout {
    
    private $_eventManager;
    
    public function __construct(
            \Magento\Framework\Event\ManagerInterface $eventManager, 
            \Psr\Log\LoggerInterface $logger, 
            \Magento\Customer\Model\Url $customerUrl, 
            \Magento\Tax\Helper\Data $taxData, 
            \Magento\Checkout\Helper\Data $checkoutData, 
            \Magento\Customer\Model\Session $customerSession, 
            \Magento\Framework\App\Cache\Type\Config $configCacheType, 
            \Magento\Framework\Locale\ResolverInterface $localeResolver, 
            \Magento\Paypal\Model\Info $paypalInfo, 
            \Magento\Store\Model\StoreManagerInterface $storeManager, 
            \Magento\Framework\UrlInterface $coreUrl, 
            \Magento\Paypal\Model\CartFactory $cartFactory, 
            \Magento\Checkout\Model\Type\OnepageFactory $onepageFactory, 
            \Magento\Quote\Api\CartManagementInterface $quoteManagement, 
            \Magento\Paypal\Model\Billing\AgreementFactory $agreementFactory, 
            \Magento\Paypal\Model\Api\Type\Factory $apiTypeFactory, 
            \Magento\Framework\DataObject\Copy $objectCopyService, 
            \Magento\Checkout\Model\Session $checkoutSession, 
            \Magento\Framework\Encryption\EncryptorInterface $encryptor, 
            \Magento\Framework\Message\ManagerInterface $messageManager, 
            \Magento\Customer\Api\CustomerRepositoryInterface $customerRepository, 
            \Magento\Customer\Model\AccountManagement $accountManagement, 
            \Magento\Sales\Model\Order\Email\Sender\OrderSender $orderSender, 
            \Magento\Quote\Api\CartRepositoryInterface $quoteRepository, 
            \Magento\Quote\Model\Quote\TotalsCollector $totalsCollector, 
            $params = array()) {
        $this->_eventManager = $eventManager;
        parent::__construct($logger, $customerUrl, $taxData, $checkoutData, $customerSession, $configCacheType, $localeResolver, $paypalInfo, $storeManager, $coreUrl, $cartFactory, $onepageFactory, $quoteManagement, $agreementFactory, $apiTypeFactory, $objectCopyService, $checkoutSession, $encryptor, $messageManager, $customerRepository, $accountManagement, $orderSender, $quoteRepository, $totalsCollector, $params);
    }
    
    public function start($returnUrl, $cancelUrl, $button = null) {
        
        $this->_eventManager->dispatch(
            'paypal_express_start_before',
            [
                'quote' => $this->_quote
            ]
        );
        
        return parent::start($returnUrl, $cancelUrl, $button);
    }
    
}